package org.jabber.applet;

/***************************************************************************
 * The contents of this file are subject to the Jabber Open Source License
 * Version 1.0 (the "License").  You may not copy or use this file, in
 * either source code or executable form, except in compliance with the 
 * License.  You may obtain a copy of the License at 
 * 
 * http://www.jabber.com/license/ or at http://www.opensource.org/.
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the
 * License for the specific language governing rights and limitations 
 * under the License.
 * 
 * Copyrights
 * 
 * Portions created by or assigned to Jabber.com, Inc. are
 * Copyright (c) 1999-2000 Jabber.com, Inc.  All Rights Reserved.  Contact
 * information for Jabber.com, Inc. is available at http://www.jabber.com/.
 * 
 * Acknowledgements
 * 
 * Special thanks to the Jabber Open Source Contributors for their
 * suggestions and support of Jabber.
 ***************************************************************************/

/**
 * Periodically test the Jabber Server connection (periodically) so we can inform user 
 * when connection is lost.
 * 
 * @author David Scott
 */
class TestConnect extends Thread {
    /**
     * Parent applet
     */
    public JabberApplet app=null;

    /**
     * Delay timer
     */
    private int nDelay = 60000; // default 1 minute

    /**
     * Flag when we're testing (on/off)
     */
    private boolean bTest = false;

    /**
     * Delayed start
     */
    private boolean bStarted = false;

    /**
     * Constructor
     * Set var to access parent applet
     */
    TestConnect() {
        app = (JabberApplet) JabberApplet.getAppletInstance();
    }

    /**
     * Toggle testing flag on/off
     * @param bTesting set status flag
     */
    public void testing(boolean bTesting) {
        bTest = bTesting;
    }

    /**
     * Get state of testing on/off flag
     * @return true - testing on, false - testing off
     */
    public boolean testing() {
        return(bTest);
    }

    /**
     * Get state of started flag
     * @return true - started testing, false - no started
     */
    public boolean getStarted() {
        return(bStarted);
    }

    /**
     * Infinitely run thread to continuously test connection
     */
    public void run() {
        bStarted = true;
        try {
            while(true) {
                Thread.sleep(nDelay);
                if (bTest == true)
                    app.connectionTest();
            }
        } catch(InterruptedException ex) {
            ex.printStackTrace();
        }
    }
}
