package org.jabber.applet.communication;

/***************************************************************************
 * The contents of this file are subject to the Jabber Open Source License
 * Version 1.0 (the "License").  You may not copy or use this file, in
 * either source code or executable form, except in compliance with the 
 * License.  You may obtain a copy of the License at 
 * 
 * http://www.jabber.com/license/ 
 * 
 * or at
 * 
 * http://www.opensource.org/.
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the
 * License for the specific language governing rights and limitations 
 * under the License.
 * 
 * Copyrights
 * 
 * Portions created by or assigned to Jabber.com, Inc. are
 * Copyright (c) 1999-2000 Jabber.com, Inc.  All Rights Reserved.  Contact
 * information for Jabber.com, Inc. is available at http://www.jabber.com/.
 * 
 * Acknowledgements
 * 
 * Special thanks to the Jabber Open Source Contributors for their
 * suggestions and support of Jabber.
 ***************************************************************************/

/**
 * Enumeration Constants for JabberAnt
 *
 * @author		Jonathan Paulson
 * @version 	$ 0.6.4 $ 
 */
public class Constants {
    public final static int         UNABLE_TO_CONNECT	= -1001;
    public final static int         NOT_CONNECTED		= -1002;
    public final static int         SEND_FAILED			= -1003;
    public final static int         SEND_SUCCEEDED      =  1;
    private int						miValue             =  0;

    /**
     * Class Constructor
     */
    public Constants(int newVal) {
        miValue=newVal;
    }

    /**
     * Set value
     */
    public void value(int newVal) {
        miValue=newVal;
    }

    /**
     * Get Value
     *
     * @return Value
     */
    public int value() {
        return miValue;
    }

    /**
    * Returns the String Value
    * 
    * @return	String represention of the Value
    */
    public String toString() {
        return toString(miValue);
    }

    /**
    * Returns the SPECIFIED String Value
    * 
    * @return	String represention of the SPECIFIED Value
    */
    public static String toString(int value) {
        switch(value) {
        case SEND_SUCCEEDED:
            return "Send Succeeded";
        case UNABLE_TO_CONNECT:
            return "Unable to connect";
        case NOT_CONNECTED:
            return "Non connected";
        case SEND_FAILED:
            return "Send failed";
        default:
            return "UNKNOWN VALUE";
        }
    }

}
