package org.jabber.applet.communication;

/***************************************************************************
 * The contents of this file are subject to the Jabber Open Source License
 * Version 1.0 (the "License").  You may not copy or use this file, in
 * either source code or executable form, except in compliance with the 
 * License.  You may obtain a copy of the License at 
 * 
 * http://www.jabber.com/license/ 
 * 
 * or at
 * 
 * http://www.opensource.org/.
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the
 * License for the specific language governing rights and limitations 
 * under the License.
 * 
 * Copyrights
 * 
 * Portions created by or assigned to Jabber.com, Inc. are
 * Copyright (c) 1999-2000 Jabber.com, Inc.  All Rights Reserved.  Contact
 * information for Jabber.com, Inc. is available at http://www.jabber.com/.
 * 
 * Acknowledgements
 * 
 * Special thanks to the Jabber Open Source Contributors for their
 * suggestions and support of Jabber.
 ***************************************************************************/

/**
* iJabberClient is an interface, which you can implement and
* register to handle incoming Jabber Instant Messages and rawXML.
* 
* @author	Jonathan Paulson
* @version 	$ 0.7.3 $
*/
public interface IJabberClient {
    /**
    * Incoming Jabber Instant Message
    */
    public void msgReceived(String from, String type, String subject, String body, String trhread);

    /**
    * A reply to your message has been started 
    */
    //public void msgReplyStarted(String from, String msg);

    /**
    * Incoming Jabber Presence
    */
    public void presenceReceived(String to, String from, String type, String status,
                                 String priority, String show, String error, String code);

    /**
    * Incoming Jabber InfoQuery
    */
    public void infoQueryReceived(String to, String from, String ID, String type,
                                  String query, String error, String code);
    /**
    * Incoming XML received from the Jabber Server (one character at a time)
    * This is primarily used for debugging.
    */
    public void rawXML(String XML);

    /**
    * An incoming Jabber Tag and XML that currently isn't supported by JabberAnt
    */
    public void unsupportedTag(String tagName, String XMLDoc);

    /**
    * Communications Error
    */
    public void error(String str);

    /**
    * Communications Closed
    */
    public void connectionClosed();

    /**
    * Got stream id (needed for digest auth)
    */
    public void gotStreamID(String id);
};
