package org.jabber.applet.connection;

import java.net.*;
import java.io.*;
import java.util.*;
/***************************************************************************
 * The contents of this file are subject to the Jabber Open Source License
 * Version 1.0 (the "License").  You may not copy or use this file, in
 * either source code or executable form, except in compliance with the 
 * License.  You may obtain a copy of the License at 
 * 
 * http://www.jabber.com/license/ 
 * 
 * or at
 * 
 * http://www.opensource.org/.
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the
 * License for the specific language governing rights and limitations 
 * under the License.
 * 
 * Copyrights
 * 
 * Portions created by or assigned to Jabber.com, Inc. are
 * Copyright (c) 1999-2000 Jabber.com, Inc.  All Rights Reserved.  Contact
 * information for Jabber.com, Inc. is available at http://www.jabber.com/.
 * 
 * Acknowledgements
 * 
 * Special thanks to the Jabber Open Source Contributors for their
 * suggestions and support of Jabber.
 ***************************************************************************/

/**
* This class sends and receives data packets using Input/Output Streams
* over a plain TCP/IP network connection
* 
* @author	Jonathan Paulson
* @version 	$ 0.7.1 $
*/
public class ContinuousConnection extends Connection {
    private Socket moSocket = null;
    private InputStream moInputStream = null;
    private OutputStream moOutputStream = null;
    private boolean keepLooping = true;

    /**
     * @param connectionClient Reference to the Object that implements IConnectionClient
     */
    public ContinuousConnection (IConnectionClient connectionClient) {
        super(connectionClient);
    }

    /**
     * Look for new data packets from Server 
     */
    public void run() {
        while (keepLooping) {
            System.out.println("ConnectionLoop");
            if (moConnState.state() == moConnState.OPEN) {
                try {
                    //Look for Data from Server
           //NICHT f. pjava         int bytesavail = moInputStream.available();
/*                    int bytesavail=1;
                    if (bytesavail > 0) {
                        byte b[] = new byte[bytesavail];
                        int count = moInputStream.read(b, 0, bytesavail);
                        if (count != 0) {
                            String sResponse = new String( b, 0, count, "UTF8");
                            dataReceived(sResponse);
                        }
                    } else {
                        //Don't hog processor
                        try {
                            sleep(1000);
                        } catch(InterruptedException e) { }
                    }
slow but works*/
		  int count=0;
                  int count2=0;
                  //string test=">";
                  //byte testb=test.toByte;
                  byte a[] =new byte[1];
                 // a[0]=1;
                  byte b[] = new byte[4800];
                  String test= new String (a,0,1, "UTF8");
                  //System.out.println("test1");
                  //try {
                  //          sleep(10);
                  //            } catch(InterruptedException e) { }

                  do
			{
                         //System.out.println("test2"); 
                         count2=moInputStream.read(a,0,1);
			 //System.out.println("test2");
                         if (count2==0) break;
                         //count++;
                         b[count]=a[0];//1
                         //System.out.println("a b ="+a+" "+b);
                         count++;
                          test= new String (a,0,1, "UTF8");
                         // System.out.println("test="+test);
                         // try {
                           // sleep(1);
                             // } catch(InterruptedException e) { }

                        }
                  while (test.compareTo(">")!= 0);
                   // while (false);  

                  if (count != 0) {
                            String sResponse = new String( b, 0, count, "UTF8");
                            dataReceived(sResponse);

                            }


 		
                }
                catch (EOFException e) {
                    // Expected: This always occurs when server disconnects.
                    System.out.println("ContinuousConnection.run() calling disconnect(): EOF");
                    disconnect();
                } catch( IOException e ) {
                    // If Connection unexpectedly terminates call disconnect
                    System.out.println("ContinuousConnection.run() calling disconnect(): IOException");
                    disconnect();
                }
                //Don't hog processor
                try {
                    sleep(1);
                } catch(InterruptedException e) { }
            }
            else {
                //Don't hog processor
                try {
                    sleep(1000);
                } catch(InterruptedException e) { }
            }
        }
    }

    /**
     * Sends data packets to Server
     * 
     * @param str      Text to send to Server 
     * @return	      True if it was able to send Data, False otherwise 
     */
    public synchronized boolean send(String str) {
        if (moConnState.state() != moConnState.OPEN) {
            System.out.println("ContinuousConnection.Send() failed: connection not open - state is: "+moConnState.toString());
            return false;
        }

        if (moOutputStream != null) {
            try {
                moOutputStream.write(str.getBytes("UTF8"));
                moOutputStream.flush();
                return true;
            } catch( IOException e ) {
                System.out.println("ContinuousConnection.Send() failed: Exception: "+e.toString());
                error("Unable send Data");
                return false;
            }
        } else {
            System.out.println("ContinuousConnection.Send() failed: no output stream");
            error("Unable send Data, connection closed.");
            return false;
        }
    }

    /**
     * Connect to specified Server/Port
     * 
     * @param host      Host Name or IP Address 
     * @param port      Port to connect to 
     * @return	       True Connection made, False otherwise 		
     */
    public ConnectionState connect(String host, int port) {
        if (moSocket != null) {
            disconnect();
        }

        moConnState.state(ConnectionState.CONNECTION_PENDING);

        //Hook up socket Connection
        try {
            moSocket = new Socket(host, port);
            moConnState.state(moConnState.CONNECTING);
        } catch (UnknownHostException e) {
            error("UnknownHost " + host + ":" + port);
            moSocket = null;
            moConnState.state(moConnState.ERROR);
            return moConnState;
        } catch (IOException e) {
            error("Unable to connect to " + host + ":" + port);
            moSocket = null;
            moConnState.state(moConnState.ERROR);
            return moConnState;
        }

        try {
            //Hookup our reading and writting pipes to the host
            moInputStream = moSocket.getInputStream();
            moOutputStream = moSocket.getOutputStream();
            moConnState.state(moConnState.OPEN);
        } catch (IOException e) {
            moOutputStream = null;
            moInputStream = null;
            moConnState.state(moConnState.ERROR);
            return moConnState;
        }
        return moConnState;
    }

    /**
     * Disconnect from host
     * 
     */
    public void disconnect() {
        System.out.println("ContinuousConnection.disconnect() called");
        moConnState.state(moConnState.CLOSING);
        try {
            //Close cleanly where possible
            if (moOutputStream != null) {
                moOutputStream.close();
            }

            if (moInputStream != null) {
                moInputStream.close();
            }

            if (moSocket != null) {
                moSocket.close();
            }
        } catch (IOException e) {
            //Ignore
        }

        if (moConnectionClient != null) {
            moConnectionClient.connectionClosed();
        }

        moSocket = null;
        moOutputStream = null;
        moInputStream = null;

        moConnState.state(moConnState.CLOSED);
    }

    /**
     * Prepare the instance of ContinuousConnection to be removed.
     * This stopps the connection loop.
     */
    public void cleanup() {
        disconnect();
        keepLooping = false;
    }
}
